<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"> 
<xsl:output method="html"/> 

<xsl:variable name="curLang">DE</xsl:variable>

<xsl:template match="/"> 
<html> 
<body> 
<H1>MSRFMEA XSL Stylesheet. </H1>

<H3><U>Fmea-Projekte/Fmea-Projects:</U></H3>
<ol><xsl:for-each select="//MSRFMEA/FM-PROJECTS/FM-PROJECT"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-PROJECT"/>
	</li>
	<BR><B>Strukturen/Structures:</B></BR>
	<ol>
	<xsl:for-each select="FM-STRUCTURE-REFS/FM-STRUCTURE-REF"> 
		<li>
		<xsl:call-template name="getStructure"> 
		<xsl:with-param name="fm-struc-ref" select="@ID-REF"/>
		</xsl:call-template>
		</li>
	</xsl:for-each>
	</ol>
</xsl:for-each>
</ol>

<H3><U>Strukturen/Structures:</U></H3>
<xsl:for-each select="//MSRFMEA/FM-STRUCTURES/FM-STRUCTURE"> 
	<h4><xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	</h4>	
	<ul><xsl:for-each select="FM-STRUCTURE-ROOT/FM-STRUCTURE-ELEMENT-REF"> 
		<li><xsl:call-template name="getStructureElement"> 
		<xsl:with-param name="fm-se-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
</xsl:for-each>

<H3><U>Im Dokument verwendete Sprachen/used Languages (default is DE):</U></H3>
<ul><xsl:for-each select="//MSRFMEA/ADMIN-DATA/USED-LANGUAGES/L-10"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:for-each>
</ul>

<H3><U>Im Dokument enthaltene Personen/used persons:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-HEAD/COMPANIES/COMPANY/TEAM-MEMBERS/TEAM-MEMBER/LONG-NAME/L-4"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:for-each>
</ul>

<H3><U>Fmea-Systemelemente/Systemelements:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-STRUCTURE-ELEMENTS/FM-STRUCTURE-ELEMENT/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Funktionstypen/Functiontypes:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-FUNCTION-TYPES/FM-FUNCTION-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: green</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Merkmalstypen/Requirementtypes:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-CHARACTERISTIC-TYPES/FM-CHARACTERISTIC-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: lightblue</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Fehlfunktionstypen/Failuretypes:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-FAULT-TYPES/FM-FAULT-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: red</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Betriebszustandstypen/Operatingconditiontypes:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-OPERATING-CONDITION-TYPES/FM-OPERATING-CONDITION-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: brown</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

<H3><U>Fmea-Massnahmentypen/Actiontypes:</U></H3>
<ul><xsl:for-each select="//MSRFMEA/FM-ACTION-TYPES/FM-ACTION-TYPE/LONG-NAME/L-4"> 
<xsl:if test="@L=$curLang"> 
	<li> 
	<xsl:attribute name="style">color: grey</xsl:attribute>
	<xsl:value-of select="."/>
	</li>
</xsl:if>
</xsl:for-each>
</ul>

</body>
</html>
</xsl:template>


<xsl:template name="getStructure"> 
<xsl:param name="fm-struc-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-STRUCTURES/FM-STRUCTURE[$fm-struc-ref = @ID]"> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<xsl:value-of select="FM-STRUCTURE"/>
	<BR><B>Strukturvarianten:</B></BR>
	<ul><xsl:for-each select="FM-VARIANT-REFS/FM-VARIANT-REF"> 
		<xsl:call-template name="getVariant"> 
		<xsl:with-param name="fm-var-ref" select="@ID-REF"/>
		</xsl:call-template>
	</xsl:for-each></ul>
</xsl:for-each>
</xsl:template>

<xsl:template name="getVariant"> 
<xsl:param name="fm-var-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-VARIANTS/FM-VARIANT[$fm-var-ref = @ID]"> 
	<li>
	<xsl:attribute name="style">color: black</xsl:attribute>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	</li>
</xsl:for-each>
</xsl:template>

<xsl:template name="getStructureElement"> 
<xsl:param name="fm-se-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-STRUCTURE-ELEMENTS/FM-STRUCTURE-ELEMENT[$fm-se-ref = @ID]"> 
	<xsl:attribute name="style">color: black</xsl:attribute>
	<i><xsl:value-of select="SHORT-NAME"/>. </i>
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
	<ul><xsl:for-each select="FM-SE-FUNCTIONS/FM-FUNCTION-REF"> 
		<li><xsl:call-template name="getFunctions"> 
		<xsl:with-param name="fm-func-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
	<ul><xsl:for-each select="FM-SE-CHARACTERISTICS/FM-CHARACTERISTIC-REF"> 
		<li><xsl:call-template name="getCharacteristics"> 
		<xsl:with-param name="fm-func-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
	<ul><xsl:for-each select="FM-SE-DECOMPOSITION/FM-STRUCTURE-ELEMENT-REF"> 	
		<li><xsl:call-template name="getStructureElement"> 
		<xsl:with-param name="fm-se-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
	</xsl:for-each>
</xsl:template>

<xsl:template name="getFunctions"> 
<xsl:param name="fm-func-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-FUNCTIONS/FM-FUNCTION[$fm-func-ref = @ID]"> 
	<xsl:attribute name="style">color: green</xsl:attribute>
	<xsl:value-of select="SHORT-NAME"/>. 
	<xsl:call-template name="getFunctionName">
        <xsl:with-param name="Function-Ref-ID" select="FM-FUNCTION-TYPE-REF/@ID-REF"/>
	</xsl:call-template> 	
	<xsl:value-of select="FM-FUNCTION"/>
	<ul><xsl:for-each select="FM-FAULT-REFS/FM-FAULT-REF"> 
		<li><xsl:call-template name="getFailures"> 
		<xsl:with-param name="fm-fail-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
	<ul><xsl:for-each select="FM-ERROR-DETECTION-REFS/FM-ERROR-DETECTION-REF"> 
		<li><xsl:call-template name="getErrorDetections"> 
		<xsl:with-param name="fm-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
	<ul><xsl:for-each select="FM-ERROR-RESPONSE-REFS/FM-ERROR-RESPONSE-REF"> 
		<li><xsl:call-template name="getErrorResponss"> 
		<xsl:with-param name="fm-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
</xsl:for-each>
</xsl:template>

<xsl:template name="getCharacteristics"> 
<xsl:param name="fm-func-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-CHARACTERISTICS/FM-CHARACTERISTIC[$fm-func-ref = @ID]"> 
	<xsl:attribute name="style">color: lightblue</xsl:attribute>
	<xsl:value-of select="SHORT-NAME"/>. 
	<xsl:call-template name="getCharName">
        <xsl:with-param name="Function-Ref-ID" select="FM-CHARACTERISTIC-TYPE-REF/@ID-REF"/>
	</xsl:call-template> 	
	<xsl:value-of select="FM-CHARACTERISTIC"/>
	<ul><xsl:for-each select="FM-FAULT-REFS/FM-FAULT-REF"> 
		<li><xsl:call-template name="getFailures"> 
		<xsl:with-param name="fm-fail-ref" select="@ID-REF"/>
		</xsl:call-template></li>
	</xsl:for-each></ul>
</xsl:for-each>
</xsl:template>

<xsl:template name="getFailures"> 
<xsl:param name="fm-fail-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-FAULTS/FM-FAULT[$fm-fail-ref = @ID]"> 	
	<xsl:attribute name="style">color: red</xsl:attribute>
	<xsl:value-of select="SHORT-NAME"/>.
	<xsl:call-template name="getFaultName">
        <xsl:with-param name="Fault-Ref-ID" select="FM-FAULT-TYPE-REF/@ID-REF"/>
	</xsl:call-template> 		
	
	<ul><xsl:for-each select="FM-TASK-HISTORY/FM-TASK-SETS"> 				
		<li><xsl:attribute name="style">color: black</xsl:attribute>
		<xsl:for-each select="LONG-NAME/L-4"> 
			<xsl:value-of select="."/>
		</xsl:for-each>
		- <xsl:value-of select="DATE-1"/></li>
		<xsl:value-of select="FM-TASK-SETS"/>
		<ul><xsl:for-each select="FM-TASK-SET"> 
			<li><xsl:attribute name="style">color: black</xsl:attribute>
			<xsl:for-each select="LONG-NAME/L-4"> 
				<xsl:value-of select="."/>
			</xsl:for-each></li>
			<xsl:value-of select="FM-TASK-SET"/>
			<ul><xsl:for-each select="FM-OCCURRENCE-TASKS/FM-ACTION-REF"> 
				<li><xsl:call-template name="getAction"> 
				<xsl:with-param name="fm-action-ref" select="@ID-REF"/>
				</xsl:call-template></li>
			</xsl:for-each>
			<xsl:for-each select="FM-DETECTION-TASKS/FM-ACTION-REF"> 
				<li><xsl:call-template name="getAction"> 
				<xsl:with-param name="fm-action-ref" select="@ID-REF"/>
				</xsl:call-template></li>
			</xsl:for-each></ul>
		</xsl:for-each></ul>
	</xsl:for-each></ul>
</xsl:for-each>
</xsl:template>

<xsl:template name="getAction"> 
<xsl:param name="fm-action-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-ACTIONS/FM-ACTION[$fm-action-ref = @ID]"> 	
	<xsl:call-template name="getActionName">
        <xsl:with-param name="Action-Ref-ID" select="FM-ACTION-TYPE-REF/@ID-REF"/>
	</xsl:call-template> 	
</xsl:for-each>
</xsl:template>

<xsl:template name="getErrorDetections"> 
<xsl:param name="fm-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-ERROR-DETECTIONS/FM-ERROR-DETECTION[$fm-ref = @ID]"> 	
	<xsl:attribute name="style">color: brown</xsl:attribute>
	<xsl:value-of select="SHORT-NAME"/>.
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>	
</xsl:for-each>
</xsl:template>

<xsl:template name="getErrorResponss"> 
<xsl:param name="fm-ref"/> 
<xsl:for-each select="//MSRFMEA/FM-ERROR-RESPONSS/FM-ERROR-RESPONSE[$fm-ref = @ID]"> 	
	<xsl:attribute name="style">color: brown</xsl:attribute>
	<xsl:value-of select="SHORT-NAME"/>.
	<xsl:for-each select="LONG-NAME/L-4[@L = $curLang]"> 
		<xsl:value-of select="."/>
	</xsl:for-each>
</xsl:for-each>
</xsl:template>


<xsl:template name="getFunctionName">   <!-- Start of Template getFunctionName-->
<xsl:param name="Function-Ref-ID"/>  
        <xsl:for-each select="//MSRFMEA/FM-FUNCTION-TYPES/FM-FUNCTION-TYPE[@ID=$Function-Ref-ID]"> 
	<xsl:attribute name="style">color: green</xsl:attribute>
	<xsl:value-of select="LONG-NAME/L-4[@L = $curLang]"/>
        </xsl:for-each>
</xsl:template> <!-- End of Template getFunctionName--> 

<xsl:template name="getCharName">   <!-- Start of Template getCharName-->
<xsl:param name="Function-Ref-ID"/>  
        <xsl:for-each select="//MSRFMEA/FM-CHARACTERISTIC-TYPES/FM-CHARACTERISTIC-TYPE[@ID=$Function-Ref-ID]">
	<xsl:attribute name="style">color: lightblue</xsl:attribute>
	<xsl:value-of select="LONG-NAME/L-4[@L = $curLang]"/>
        </xsl:for-each> 
</xsl:template> <!-- End of Template getCharName--> 

<xsl:template name="getFaultName">   <!-- Start of Template getFaultName-->
<xsl:param name="Fault-Ref-ID"/>  
        <xsl:for-each select="//MSRFMEA/FM-FAULT-TYPES/FM-FAULT-TYPE[@ID=$Fault-Ref-ID]"> 
	<xsl:attribute name="style">color: red</xsl:attribute>
	<xsl:value-of select="LONG-NAME/L-4[@L = $curLang]"/>
        </xsl:for-each>
</xsl:template> <!-- End of Template getFaultName--> 

<xsl:template name="getActionName">   <!-- Start of Template getActionName-->
<xsl:param name="Action-Ref-ID"/>  
        <xsl:for-each select="//MSRFMEA/FM-ACTION-TYPES/FM-ACTION-TYPE[@ID=$Action-Ref-ID]">
	<xsl:attribute name="style">color: grey</xsl:attribute>
	<xsl:value-of select="LONG-NAME/L-4[@L = $curLang]"/>
        </xsl:for-each>
</xsl:template> <!-- End of Template getActionName--> 

</xsl:stylesheet>
